#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

set<pair<int, int>> used;
set<pair<int, int>> have;

bool check_in(int x)
{
	if (used.empty())
	{
		return false;
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});

		if (it == used.begin())
		{
			return false;
		}
		else
		{
			--it;

			return it->first <= x && x <= it->second; 
		}
	}
}

vector<int> next(int x, int h)
{
	auto it = --used.upper_bound({x + 1, -1});
	
	vector<int> ans;
	
	if (it->second + 1 <= h)
	{
		ans.push_back(it->second + 1);
	}
	if (it->first - 1 > 0)
	{
		ans.push_back(it->first - 1);
	}

	return ans;
}

void insert(int x)
{
	if (used.empty())
	{
		used.insert({x, x});
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});
	

		if (it == used.begin())
		{
			if (x + 1 == it->first)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else if (it == used.end())
		{
			--it;
			if (it->second == x - 1)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				++mem.second;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else
		{
			auto itr = it;
			auto itl = --it;

			if (itl->second == x - 1 && x + 1 == itr->first)
			{
				pair<int, int> meml = *itl;
				pair<int, int> memr = *itr;
				used.erase(meml);
				used.erase(memr);
				used.insert({meml.first, memr.second});
			}
			else if (itl->second == x - 1)
			{
				pair<int, int> mem = *itl;
				used.erase(itl);
				++mem.second;
				used.insert(mem);
			}
			else if (x + 1 == itr->first)
			{
				pair<int, int> mem = *itr;
				used.erase(itr);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
	}
}

int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int h = atoi(argv[2]);
	int last_fuck = atoi(argv[3]);
	int last_sub = atoi(argv[4]);
	int t = 0;

	ll sum = 0;
	for (int i = 0; i < n - 1; ++i)
	{
		have.insert({i + 1, rnd.next(1, 2)});
		sum += have.rbegin()->second;
	}

	ll h_ptr = 0;
	while (h_ptr < n - 1)
	{
		h_ptr += last_fuck;
		++t;
	}

	for (int i = 0, target = rnd.next(4, 5); i < target; ++i)
	{
		h_ptr += last_fuck;
		++t;
	}
	
	have.insert({h_ptr + sum + last_fuck - 1, last_sub});
	++t;
	h_ptr = h_ptr + sum + last_fuck - 2 - sum;
	last_fuck -= last_sub;
	
	h -= (h - h_ptr) % last_fuck;
	t += (h - h_ptr) / last_fuck;

	printf("%d %d %d\n", n, h, t);
	for (auto it = have.begin(); it != have.end(); ++it)
	{
		printf("%d %d\n", it->first, it->second);
	}

	return 0;
}


