#include <bits/stdc++.h>
using ll = long long;
using ld = long double;
using namespace std;

constexpr  int MAXN = 228228;
constexpr ll INF = 1ll << 56;

ll h[MAXN];
ll v[MAXN];
int n;
ll totalTime, height;

// ReSharper disable once CppNotAllPathsReturnValue
ll getTime(ll x) {
    int p = 0;
    ll sum = 0;
    ll curHeight = 0;  
    ll curTime = 0;

    while (p <= n) {
        ll each = x - sum;
        if (each <= 0) {
            return INF;
        }

        ll tillNext = max(h[p] - 1 - x - curHeight, 0ll) / each;
        ll tillH = (height - curHeight + each - 1) / each;

        if (tillH <= tillNext) {
            return curTime + tillH;
        }

        curTime += (tillNext + 1);
        ll newHeight = curHeight + tillNext * each + x;

        int newP = p;
        while (h[newP] <= newHeight) {
            ++newP;
        }

        ll newSum = sum;
        for (int i = newP - 1; i >= p; --i) {
            newSum += v[i];
            newHeight = max(h[i] - 1, newHeight - v[i]);
        }

        newHeight -= sum;

        curHeight = newHeight;
        sum = newSum;
        p = newP;
    }

    assert(false);
}

int main() {
#ifdef PAUNSVOKNO
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20); cout.tie(nullptr);
    cin >> n >> height >> totalTime;
    for (int i = 0; i < n; ++i) {
        cin >> h[i] >> v[i];
    }

    h[n] = INF * 2;
    h[n + 1] = INF * 4;

    ll l = 0, r = INF;
    while (l < r) {
        ll md = (l + r) / 2;
        if (getTime(md) <= totalTime) {
            r = md;
        } else {
            l = md + 1;
        }
    }

    cout << l << "\n";
}