#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);

    int n, m, q, k;
    cin >> n >> m >> q >> k;
    vector<long long> offline(m);
    for (auto& i : offline)
        cin >> i;

    vector< vector<long long> > table(n, vector<long long>(m));
    vector<long long> minSum(n, 0ll), maxSum(n, 0ll);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            cin >> table[i][j];
            minSum[i] += table[i][j];
            maxSum[i] += (table[i][j] + offline[j] == k ? k : table[i][j]);
        }

    for (int j = 0; j < q; j++) {

        int t, id;
        cin >> t >> id;
        id--;

        if (t == 1) {
            int ansX = 1, ansY = 1;
            for (int i = 0; i < n; i++)
                if (i != id){
                    if (maxSum[i] > minSum[id])
                        ansY++;
                    if (minSum[i] > maxSum[id])
                        ansX++;
                }
            cout << ansX << ' ' << ansY << endl;
        } else {
            int taskId;
            long long ball;
            cin >> taskId >> ball;
            taskId--;

            if (table[id][taskId] + offline[taskId] == k) {
                minSum[id] += ball - table[id][taskId];
                maxSum[id] -= k - ball;
            }
        }
    }

    return 0;
}