#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);

    int n, m, q, k;
    cin >> n >> m >> q >> k;
    vector<long long> offline(m);
    for (auto& i : offline)
        cin >> i;

    vector< vector<long long> > table(n, vector<long long>(m));
    vector<long long> minSum(n, 0ll), maxSum(n, 0ll);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            cin >> table[i][j];
            minSum[i] += table[i][j];
            maxSum[i] += (table[i][j] + offline[j] == k ? k : table[i][j]);
        }

    vector<long long> a(n), b(n);
    vector< pair<int, int> > ans(n);
    bool changed = true;

    for (int j = 0; j < q; j++) {

        int t, id;
        cin >> t >> id;
        id--;

        if (t == 1) {
            if (changed) {
                changed = false;
                for (int i = 0; i < n; i++) {
                    a[i] = maxSum[i];
                    b[i] = minSum[i];
                }

                sort(a.begin(), a.end());
                sort(b.begin(), b.end());

                for (int i = 0; i < n; i++) {
                    int l = 1 + n - int(upper_bound(b.begin(), b.end(), maxSum[i]) - b.begin());
                    int r = (maxSum[i] > minSum[i] ? 0 : 1) + n - int(upper_bound(a.begin(), a.end(), minSum[i]) - a.begin());
                    ans[i] = {l, r};
                }
            }

            cout << ans[id].first << ' ' << ans[id].second << endl;
        } else {
            changed = true;
            int taskId;
            long long ball;
            cin >> taskId >> ball;
            taskId--;

            if (table[id][taskId] + offline[taskId] == k) {
                minSum[id] += ball - table[id][taskId];
                maxSum[id] -= k - ball;
            }
        }
    }

    return 0;
}