#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <stdlib.h>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#include "testlib.h"
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_N[] = {100 * 1000, 15, 100, 500, 10000};
const int MAX_M[] = {100 * 1000, 15, 52, 500, 1000};
const int DIFF[] = {0, 0, 1, 0, 0};
const int nmax = 1000;

int was[nmax];

int diff(const string &a) {
    for (int i = 0; i < nmax; i++) {
        was[i] = 0;
    }
    for (char u : a) {
        if (was[u]) {
            return false;
        }
        was[u]++;
    }
    return true;
}

void val(const string &a) {
    for (char u : a) {
        ensuref(('a' <= u && u <= 'z') || ('A' <= u && u <= 'Z'), "Strings contain wrong symbols");
    }
}

int main(int argc, char **argv) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    string s = inf.readString();
    string t = inf.readString();
    inf.readEof();
    val(s);
    val(t);
    if (DIFF[group]) {
        ensuref(diff(t), "String t contain same symbols");
    }
    ensuref((int)s.length() <= MAX_N[group], "String s is too big for this group");
    ensuref((int)t.length() <= MAX_M[group], "String t is too big for this group");
    ensuref((int)t.length() <= s.length(), "string t should not be longer than string s");
    ensuref(1 <= (int)s.length(), "String s is too small");
    ensuref(2 <= (int)t.length(), "String t is too small");
    return 0;
}
