#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);
	if (argc != 6) {
		cerr << "n, k, buckets, maxC, seed" << endl;

		return 1;
	}

	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	int b = atoi(argv[3]);
	long long c = atoll(argv[4]);

	vector <set <long long> > ts(2 * b);
	for (int i = 0; i < n; i++) {
		int cb = 2 * rnd.next(0, b - 1);
		long long lb = 1 + c / (2 * b) * cb;
		long long rb = 1 + c / (2 * b) * (cb + 1);
		int csz = (int) ts[cb].size();
		while ((int) ts[cb].size() == csz) {
			ts[cb].insert(rnd.next(lb, rb));
		}
	}
	
	printf("%d %d\n", n, k);
	int cnt = 0;
	for (int i = 0; i < 2 * b; i++) {
		for (auto& e : ts[i]) {
			printf("%lld", e);
			cnt++;
			printf("%c", " \n"[cnt == n]);
		}
	}
    return 0;
}