#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);
	if (argc != 5) {
		cerr << "n, k, maxC, seed" << endl;

		return 1;
	}

	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	long long c = atoll(argv[3]);

	set <long long> ts;
	while ((int) ts.size() < n) {
		ts.insert(rnd.next(1ll, c));
	}

	printf("%d %d\n", n, k);
	vector <long long> t(ts.begin(), ts.end());
	for (int i = 0; i < n; i++) {
		printf("%lld%c", t[i], " \n"[i == n - 1]);
	}

    return 0;
}