#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int kMinN = 1;
const int kMaxN[3] = {100, 100, 100 * 1000};
const int kMinK = 1;
const int kMaxK[3] = {100, 100, 1000 * 1000 * 1000};
const long long kMinC = 1;
const long long kMaxC[3] = {100, 100, 1000ll * 1000 * 1000 * 1000 * 1000 * 1000};

int main(int argc, char ** argv) {
	registerValidation(argc, argv);
	int g = atoi(validator.group().data());
	ensuref(0 <= g && g <= 2, "Incorrect group index");

    int n = inf.readInt(kMinN, kMaxN[g], "n");
    inf.readSpace();
    inf.readInt(kMinK, kMaxK[g], "k");
    inf.readEoln();
    long long lst = kMinC - 1ll;
	for (int i = 0; i < n; i++) {
		lst = inf.readLong(lst + 1ll, kMaxC[g], format("t[%d]", i + 1));
		if (i < n - 1) {
			inf.readSpace();
		} else {
			inf.readEoln();				
		}
	}
	
	inf.readEof();

    return 0;
}