#include "testlib.h"
#include <iostream>

using namespace std;

int main(int argc, char* argv[]) {
  registerGen(argc, argv, 1);

  if (argc != 4) {
    cerr << "Usage: len, random_tail_len, seed" << endl;
    return 1;
  }

  int len = atoi(argv[1]);
  int random_tail_len = atoi(argv[2]);
  int num_nines = len - random_tail_len;
  cout << rnd.next(format("[9]{%d,%d}[0-9]{%d,%d}", num_nines, num_nines, random_tail_len, random_tail_len)) << endl;
}