#include "testlib.h"

const unsigned long long MAXLEN[] = {
  18,
  18,
  100,
  1000,
  2 * 1000,
  5 * 1000,
  10 * 1000,
  20 * 1000,
  50 * 1000,
  75 * 1000,
  100 * 1000,
  150 * 1000,
  200 * 1000,
  250 * 1000,
  300 * 1000,
  400 * 1000,
  500 * 1000
};

int main(int argc, char **argv) {
  registerValidation(argc, argv);
  int group = atoi(validator.group().data());
  ensuref(0 <= group && group <= 16, "Incorrect test group");

  std::string pattern_string = "[1-9][0-9]{0," + vtos(MAXLEN[group] - 1) + "}" + "|" +
                               "1[0]{0," + vtos(MAXLEN[group]) + "}";
  std::string N;
  
  inf.readWordTo(N, pattern_string);  
  inf.readEoln();
  inf.readEof();
  return 0;
}