#include <bits/stdc++.h>
#include "testlib.h"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

const int MAXN = 1000 * 1000;
const int MAXA = 1000 * 1000 * 1000;
ll a[MAXN + 1], sum[MAXN + 1], n;

ll readAns(InStream& in, TResult flag) {
    ll ans = in.readLong();
    int l = in.readInt(1, n);
    int r = in.readInt(1, n);
    if (l > r) {
        quitf(flag, "l should be less or equal to r");
    }
    if (a[l] != a[r]) {
        quitf(flag, "segment has different values on ends");
    }
    if (sum[r] - sum[l - 1] != ans) {
        quitf(flag, "segment has wrong sum");
    }
    return ans;
}

int main(int argc, char * argv[]) {
    //cin.tie(0), ios::sync_with_stdio(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    for(int i = 1; i <= n; i++) {
        a[i] = inf.readInt();
        sum[i] = sum[i - 1] + a[i];
    }

    ll part_ans = readAns(ouf, _wa);
    ll jury_ans = readAns(ans, _fail);
    if (part_ans < jury_ans) {
        quitf(_wa, "participant's answer is %lld, but jury's answer is %lld", part_ans, jury_ans);
    }
    else if (part_ans == jury_ans)
        quitf(_ok, "");
    else
        quitf(_fail, "participant has better solution");
    return 0;
}