#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<int> > v;
vector<int> used;

bool flag = 0;

void dfs(int u, int a, int b) {
    used[u] = 2;
    for (int i = 0; i < v[u].size(); i++) {
        if (used[v[u][i]] == 2) {
            flag = 1;
        } else if (used[v[u][i]] == 0) {
            dfs(v[u][i], a, b);
        }
    }
    if (a == u) {
        if (used[b] == 2) {
            flag = 1;
        } else if (used[b] == 0) {
            dfs(b, a, b);
        }
    }
    used[u] = 1;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int cnt = 0;
    v.resize(n);
    used.resize(n);
    while (cnt < m) {
        flag = 0;
        int a = rnd.next(n);
        int b = rnd.next(n);
        used.assign(n, 0);
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i, a, b);
            }
        }
        if (!flag) {
            v[a].push_back(b);
            cnt++;
        }
    }
    vector<pair<int, int> > edges;
    cout << n << ' ' << m << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < v[i].size(); j++) {
            edges.push_back(make_pair(i + 1, v[i][j] + 1));
        }
    }
    shuffle(edges.begin(), edges.end());
    for (int i = 0; i < edges.size(); i++) {
        cout << edges[i].first << ' ' << edges[i].second << endl;
    }
}
