#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    
    int n = atoi(argv[1]);
    int mode = atoi(argv[2]);
    vector<pair<int, int> > edges;
    cout << n << ' ' << n * (n - 1) / 2 << endl;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            edges.push_back(make_pair(i + 1, j + 1));
        }
    }
    if (mode == 1) {
        shuffle(edges.begin(), edges.end());
    }
    for (int i = 0; i < edges.size(); i++) {
        cout << edges[i].first << ' ' << edges[i].second << endl;
    }
}
