#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<int>> v, v2;
vector<bool> used, used2;
vector<int> mt, mt2;

int t1, t2, a, b;

bool dfs_left(int u) {
    if (used[u]) {
        return false;
    }
    used[u] = 1;
    for (int i = 0; i < v[u].size(); i++) {
        int to = v[u][i];
        if (to == b - 1 || to == t1) {
            continue;
        }
        if (mt[to] == -1 || dfs_left(mt[to])) {
            mt[to] = u;
            mt2[u] = to;
            return true;
        }
    }
    return false;
}

bool dfs_right(int u) {
    if (used2[u]) {
        return false;
    }
    used2[u] = 1;
    for (int i = 0; i < v2[u].size(); i++) {
        int to = v2[u][i];
        if (to == a - 1 || to == t2) {
            continue;
        }
        if (mt2[to] == -1 || dfs_right(mt2[to])) {
            mt2[to] = u;
            mt[u] = to;
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    v.resize(n);
    v2.resize(n);
    used.resize(n);
    used2.resize(n);
    mt.resize(n, -1);
    mt2.resize(n, -1);
    int cnt = 0;
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        v[a - 1].push_back(b - 1);
        v2[b - 1].push_back(a - 1);
        used.assign(n, false);
        used2.assign(n, false);
        t1 = mt2[a - 1];
        t2 = mt[b - 1];
        int tmp = 0;
        mt2[a - 1] = b - 1;
        mt[b - 1] = a - 1;
        if (t1 != -1) {
            mt[t1] = -1;
        }
        if (t2 != -1) {
            mt2[t2] = -1;
        }
        if (t1 == -1 || dfs_right(t1)) {
            tmp++;
        }
        if (t2 == -1 || dfs_left(t2)) {
            tmp++;
        }
        if (tmp == 0) {
            mt2[a - 1] = t1;
            mt[b - 1] = t2;
            mt[t1] = a - 1;
            mt2[t2] = b - 1;
        } else if (tmp == 2) {
            cnt++;
        }
        cout << n - cnt << ' ';
    }
    cout << endl;
}
