#include <bits/stdc++.h>

typedef long long ll;
typedef long long llong;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

/*
ll pw(ll a, ll b) {
	ll ans = 1; while (b) {
		while (!(b & 1)) b >>= 1, a = (a * a) % MOD;
		ans = (ans * a) % MOD, --b;
	} return ans;
}
*/

const int MAXN = 120000;
const int SQ = 40000;

ll base[MAXN];
ll sum[MAXN];
ll go[MAXN];
ll h[MAXN];
ll v[MAXN];

ll H, T;
int n;

ll get(int k, ll x) {
	return x - max(base[k], x - sum[k]);
}

ll gget(ll x) {
	int y = upper_bound(h, h + n, x) - h;
	return get(y - 1, x);
}

int check(ll x) {
	for (ll i = 0; i < SQ; ++i) {
		int lb = -1;
		int rb = n;
		while (rb - lb > 1) {
			int mid = (lb + rb) >> 1;
			ll l = 0;
			if (mid + 1 < n)
				l = x - get(mid, h[mid + 1] - 1);
			else
				l = x - sum[n - 1];
			if (l > i)
				lb = mid;
			else
				rb = mid;
		}
		if (rb == n) {
			go[i] = H;
			continue;
		}
		ll l = h[rb] - 1;
		ll r = 0;
		if (rb + 1 < n)
			r = h[rb + 1] - 1;
		else
			r = H + x;
		while (r - l > 1) {
			ll mid = (l + r) >> 1;
			if (x - get(rb, mid) > i)
				l = mid;
			else
				r = mid;
		}
		go[i] = min(H, r - x);
	}
	ll cur = 0;
	ll cnt = 0;
	while (cur < H) {
		ll gg = x - gget(cur + x);
		if (gg <= 0)
			return 0;
		if (gg >= SQ) {
			cur += gg;
			++cnt;
			continue;
		}
		ll g = (go[gg - 1] - cur + gg - 1) / gg;
		cur += g * gg;
		cnt += g;
	}
	if (cnt <= T)
		return 1;
	return 0;
}

int main() {
	scanf("%d%lld%lld", &n, &H, &T);
	for (int i = 1; i <= n; ++i)
		scanf("%lld%lld", h + i, v + i);
	h[0] = 0;
	v[0] = 0;
	++n;
	ll cs = 0;
	for (int i = 0; i < n; ++i) {
		cs += v[i];
		sum[i] = cs;
	}
	base[0] = 0;
	for (int i = 1; i < n; ++i)
		base[i] = h[i] - 1 - get(i - 1, h[i] - 1);
	ll lb = 0;
	ll rb = 1e15;
	while (rb - lb > 1) {
		ll mid = (lb + rb) >> 1;
		if (check(mid))
			rb = mid;
		else
			lb = mid;
	}
	cout << rb << "\n";
	return 0;
}


