#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 100 + 5;

struct hole
{
	ll h;
	ll v;
};

int n;
ll h, t;
hole arr[MAX_N]; 
ll sum = 0;

bool check(ll m)
{
	ll h_now = 0;
	ll last;
	for (int i = 0; h_now < h && i < t; ++i)
	{
		last = h_now;
		h_now += m;
		for (int j = n - 1; j >= 0; --j)
		{
			if (arr[j].h <= h_now)
			{
				h_now = max(arr[j].h - 1, h_now - arr[j].v);
			}
		}

		if (last == h_now)
		{
			break;
		}
	}
	
	return h <= h_now;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d%lld%lld", &n, &h, &t);
	
	for (int i = 0; i < n; ++i)
	{
		scanf("%lld%lld", &arr[i].h, &arr[i].v);
		sum += arr[i].v;
	}
	
	assert(n == 2);

	ll l = sum;
	ll r = sum + h; // fill in one second

	while (r - l > 1)
	{
		ll m = (l + r) >> 1;

		if (check(m))
			r = m;
		else
			l = m;
	}

	printf("%lld\n", r);

	return 0;
}

