#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define sz(v) (int)(v).size()
#define all(v) (v).begin(), (v).end()

pair<int, int> gen_edge(int n)
{
	assert(n > 1);
	int a = rnd.next(1, n);
	
	int b;
	do
	{
		b = rnd.next(1, n);
	} while(a == b);
	
	return {a, b};
}

template<class T>
void print_vec(const vector<T> &v)
{
	for(int i = 0; i < sz(v); ++i)
	{
		cout << v[i];
		
		if(i + 1 == sz(v))
		{
			cout << endl;
		}
		else
		{
			cout << " ";
		}
	}
}

template<class T>
vector<T> gen_vec_rnd(const int n, const T lw, const T up)
{
	vector<T> v(n);
	
	for(auto &i : v)
	{
		i = rnd.next(lw, up);
	}

	return v;
}

template<class T>
vector<T> gen_vec_srt(const int n, const T lw, const T up)
{
	auto v = gen_vec_rnd(n, lw, up);
	sort(all(v));
	
	return v;
}

template<class T>
vector<T> vec_swaps(vector<T> v, int cnt)
{
	for(int i = 0; i < cnt; ++i)
	{
		swap(v[rnd.next(0, sz(v) - 1)], v[rnd.next(0, sz(v) - 1)]);
	}

	return v;
}
