#include "testlib.h"

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int kMinWH[] = {1, 1, 1, 1, 1};
const int kMaxWH[] = {5, 5, 100, 10 * 1000, 1000 * 1000 * 1000};

int main(int argc, char ** argv) {
	registerValidation(argc, argv);
	
	int group = atoi(validator.group().data());
    ensuref(0 <= group && group <= 4, "unknown group id");

	inf.readInt(kMinWH[group], kMaxWH[group], "w");
	inf.readSpace();
	inf.readInt(kMinWH[group], kMaxWH[group], "h");
	inf.readEoln();
	inf.readEof();

    return 0;
}