#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

string s, t;

void readInput() {
    s = inf.readString();
    t = inf.readString();
}

bool issubseq(const string &a, const string &b) {
    int len = 0;
    for (int i = 0; i < (int)a.length(); i++) {
        if (a[i] == b[len]) {
            len++;
        }
        if (len == (int)b.length()) {
            return true;
        }
    }
    return len == (int)b.length();
}

bool val(const string &a) {
    for (char u : a) {
        if (!(('a' <= u && u <= 'z') || ('A' <= u && u <= 'Z'))) {
            return false;
        }
    }
    return true;
}

int readAns(InStream &ans, TResult flag) {
    string answer = ans.readString();
    if (!val(answer)) {
        ans.quitf(flag, "Printed string has wrong symbols");
    }
    if (!issubseq(s, answer)) {
        ans.quitf(flag, "Printed string is not subsequence of s");
    }
    if (issubseq(answer, t)) {
        ans.quitf(flag, "Printed string has t as subsequence");
    }
    return (int)answer.length();
}

int main(int argc, char * argv[])
{
    registerTestlibCmd(argc, argv);
    readInput();
    int answ = readAns(ans, _fail);
    int cont = readAns(ouf, _wa);
    if (cont == answ) {
        quitf(_ok, "The answers are similar");
    } else if (answ < cont) {
        quitf(_fail, "Contestant has better answer");
    } else if (answ > cont) {
        quitf(_wa, "Contestant has not optimal answer");
    }
}   
