#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

int cha(int a) {
    return ('a' + a <= 'z' ? 'a' + a : 'A' + a - 26);
}

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);
    if (argc < 3) {
        cerr << "Usage: n, m, maxchar, seed" << endl;
        return 1;
    }
    string s = "";
    int n, m, cnt;
    n = atoi(argv[1]);
    m = atoi(argv[2]);
    cnt = atoi(argv[3]);
    rnd.setSeed(atoi(argv[4]));
    for (int i = 0; i < n; i++) {
        s += cha(rnd.next(0, cnt - 1));
    }
    cout << s << endl;
    string t = "";
    int ind = 0;
    for (int i = m - 1; i >= 0; i--) {
        int x = rnd.next(ind, n - i - 1);
        ind = x + 1;
        t += s[x];
    }
    cout << t << endl;
    return 0;
}